// Code generated by go-swagger; DO NOT EDIT.

package rendering

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	"github.com/go-openapi/runtime/middleware"

	"orus.io/orus-io/rednerd/models"
)

// RenderHandlerFunc turns a function with the right signature into a render handler
type RenderHandlerFunc func(RenderParams, *models.Principal) middleware.Responder

// Handle executing the request and returning a response
func (fn RenderHandlerFunc) Handle(params RenderParams, principal *models.Principal) middleware.Responder {
	return fn(params, principal)
}

// RenderHandler interface for that can handle valid render params
type RenderHandler interface {
	Handle(RenderParams, *models.Principal) middleware.Responder
}

// NewRender creates a new http.Handler for the render operation
func NewRender(ctx *middleware.Context, handler RenderHandler) *Render {
	return &Render{Context: ctx, Handler: handler}
}

/*Render swagger:route POST /v1/render rendering render

Render a template.

If provided, the template can be a complete definition (without a "account"
and a "name"), or only a "account" and a "name" corresponding to a template
previously created with the template management API. In both case the
data must be provided.

Alternatively, a single document can be provided that will be renderer into
another type, without processing any template. In this case the "data" must
not be provided.


*/
type Render struct {
	Context *middleware.Context
	Handler RenderHandler
}

func (o *Render) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewRenderParams()

	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		r = aCtx
	}
	var principal *models.Principal
	if uprinc != nil {
		principal = uprinc.(*models.Principal) // this is really a models.Principal, I promise
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}
